#include "ttt.h"
#include "resource.h"

// ----------------------------------------
enum tileStat{NONE, XTILE, OTILE};
enum whoTurn{START,PLAYERX,PLAYERO};
enum gameStat{ONGOING,DRAW,XWON,OWON};

CMyApplication::CMyApplication(const GDAPPCONFIG& config) : CGapiApplication(config) {};

HRESULT CMyApplication::InitInstance()
{
	
	//good Moves in order
	compMoves[0] = 4;
	compMoves[1] = 0;
	compMoves[2] = 8;
	compMoves[3] = 2;
	compMoves[4] = 6;
	compMoves[5] = 1;
	compMoves[6] = 3;
	compMoves[7] = 5;
	compMoves[8] = 7;


	//background
	m_backGround = new CGapiSurface(m_pGapiDraw);

	//playex
	playerx.tokImage = new CGapiSurface(m_pGapiDraw);
	WonX = new CGapiSurface(m_pGapiDraw);
	XTurn = new CGapiSurface(m_pGapiDraw);

	//playero
	playero.tokImage = new CGapiSurface(m_pGapiDraw);
	WonO = new CGapiSurface(m_pGapiDraw);
	OTurn = new CGapiSurface(m_pGapiDraw);
	
	//tiles
	
	for (int x = 0; x < 9; x++)
	{
		board.tile[x] = new CGapiSurface(m_pGapiDraw);
	}

	
	//rect for tiles
	for (int i = 0; i < 9; i++)
	{
		board.tileRect[i].bottom = 0;
		board.tileRect[i].left	 = 0;
		board.tileRect[i].right	 = 0;
		board.tileRect[i].top	 = 0;
	}

	for (int j = 0; j < 9; j++)
	{
		board.tileStat[j] = NONE;
	}

	

	whoTurn = PLAYERX;

	return GD_OK;
};


HRESULT CMyApplication::ExitInstance()
{
	delete m_backGround;

	for (int i = 0; i < 9; i++)
	{
		delete board.tile[i];
	}
	
		
	delete playerx.tokImage;
	delete playero.tokImage;

	delete WonX;
	delete WonO;

	delete XTurn;
	delete OTurn;

	return GD_OK;
};

HRESULT CMyApplication::CreateSysMemSurfaces(CGapiDisplay* pDisplay, HINSTANCE hInstance)
{
	// Add code to create surfaces here
	m_backGround->CreateSurface(GDSURFACE_SYSTEMMEMORY,hInstance,IDR_BACKGROUND,_T("PNG"));
	
	//playerx images
	playerx.tokImage->CreateSurface(GDSURFACE_SYSTEMMEMORY,hInstance,IDB_PLAYERX,NULL);
	playerx.tokImage->SetColorKey(RGB(234,234,234));
	WonX->CreateSurface(GDSURFACE_SYSTEMMEMORY,hInstance,IDB_XWON,NULL);
	XTurn->CreateSurface(GDSURFACE_SYSTEMMEMORY,hInstance,IDB_XTURN,NULL);
	XTurn->SetColorKey(RGB(234,234,234));

	//playero images
	playero.tokImage->CreateSurface(GDSURFACE_SYSTEMMEMORY,hInstance,IDB_PLAYERO,NULL);
	playero.tokImage->SetColorKey(RGB(234,234,234));
	WonO->CreateSurface(GDSURFACE_SYSTEMMEMORY,hInstance,IDB_OWON,NULL);
	OTurn->CreateSurface(GDSURFACE_SYSTEMMEMORY,hInstance,IDB_OTURN,NULL);
	OTurn->SetColorKey(RGB(234,234,234));

	//create surface and set colorkeys for tiles
	board.tile[0]->CreateSurface(GDSURFACE_SYSTEMMEMORY,hInstance,IDB_TILE01,NULL);
	board.tile[0]->SetColorKey(RGB(234,234,234));
	board.tile1.x = 20;
	board.tile1.y = 20;
	board.tileRect[0].left   = 20;
	board.tileRect[0].top    = 20;
	board.tileRect[0].right  = 83;
	board.tileRect[0].bottom = 83;


	board.tile[1]->CreateSurface(GDSURFACE_SYSTEMMEMORY,hInstance,IDB_TILE02,NULL);
	board.tile[1]->SetColorKey(RGB(234,234,234));
	board.tile2.x = 84;
	board.tile2.y = 20;
	board.tileRect[1].left   = 84;
	board.tileRect[1].top    = 20;
	board.tileRect[1].right  = 147;
	board.tileRect[1].bottom = 83;


	board.tile[2]->CreateSurface(GDSURFACE_SYSTEMMEMORY,hInstance,IDB_TILE03,NULL);
	board.tile[2]->SetColorKey(RGB(234,234,234));
	board.tile3.x = 148;
	board.tile3.y = 20;
	board.tileRect[2].left   = 148;
	board.tileRect[2].top    = 20;
	board.tileRect[2].right  = 210;
	board.tileRect[2].bottom = 83;


	board.tile[3]->CreateSurface(GDSURFACE_SYSTEMMEMORY,hInstance,IDB_TILE04,NULL);
	board.tile[3]->SetColorKey(RGB(234,234,234));
	board.tile4.x = 20;
	board.tile4.y = 84;
	board.tileRect[3].left   = 20;
	board.tileRect[3].top    = 84;
	board.tileRect[3].right  = 83;
	board.tileRect[3].bottom = 147;


	board.tile[4]->CreateSurface(GDSURFACE_SYSTEMMEMORY,hInstance,IDB_TILE05,NULL);
	board.tile[4]->SetColorKey(RGB(234,234,234));
	board.tile5.x = 84;
	board.tile5.y = 84;
	board.tileRect[4].left   = 84;
	board.tileRect[4].top    = 84;
	board.tileRect[4].right  = 147;
	board.tileRect[4].bottom = 147;


	board.tile[5]->CreateSurface(GDSURFACE_SYSTEMMEMORY,hInstance,IDB_TILE06,NULL);
	board.tile[5]->SetColorKey(RGB(234,234,234));
	board.tile6.x = 148;
	board.tile6.y = 84;
	board.tileRect[5].left   = 148;
	board.tileRect[5].top    = 84;
	board.tileRect[5].right  = 211;
	board.tileRect[5].bottom = 147;


	board.tile[6]->CreateSurface(GDSURFACE_SYSTEMMEMORY,hInstance,IDB_TILE07,NULL);
	board.tile[6]->SetColorKey(RGB(234,234,234));
	board.tile7.x = 20;
	board.tile7.y = 148;
	board.tileRect[6].left   = 20;
	board.tileRect[6].top    = 148;
	board.tileRect[6].right  = 83;
	board.tileRect[6].bottom = 212;


	board.tile[7]->CreateSurface(GDSURFACE_SYSTEMMEMORY,hInstance,IDB_TILE08,NULL);
	board.tile[7]->SetColorKey(RGB(234,234,234));
	board.tile8.x = 84;
	board.tile8.y = 148;
	board.tileRect[7].left   = 84;
	board.tileRect[7].top    = 148;
	board.tileRect[7].right  = 147;
	board.tileRect[7].bottom = 212;



	board.tile[8]->CreateSurface(GDSURFACE_SYSTEMMEMORY,hInstance,IDB_TILE09,NULL);
	board.tile[8]->SetColorKey(RGB(234,234,234));
	board.tile9.x = 148;
	board.tile9.y = 148;
	board.tileRect[8].left   = 148;
	board.tileRect[8].top    = 148;
	board.tileRect[8].right  = 211;
	board.tileRect[8].bottom = 212;


	return GD_OK;
}

HRESULT CMyApplication::CreateVidMemSurfaces(CGapiDisplay* pDisplay, HINSTANCE hInstance)
{
	// Add code to create surfaces stored in video memory here
	return GD_OK;
}

HRESULT CMyApplication::ProcessNextFrame(CGapiSurface* pBackbuffer, DWORD dwFlags)
{
	//blit background
    pBackbuffer->BltFast(0,0,m_backGround,NULL,NULL,NULL);

	//blit board
	pBackbuffer->BltFast(board.tile1.x, board.tile1.y, board.tile[0], NULL, GDBLTFAST_KEYSRC, NULL);
	pBackbuffer->BltFast(board.tile2.x, board.tile2.y, board.tile[1], NULL, GDBLTFAST_KEYSRC, NULL);
	pBackbuffer->BltFast(board.tile3.x, board.tile3.y, board.tile[2], NULL, GDBLTFAST_KEYSRC, NULL);
	pBackbuffer->BltFast(board.tile4.x, board.tile4.y, board.tile[3], NULL, GDBLTFAST_KEYSRC, NULL);
	pBackbuffer->BltFast(board.tile5.x, board.tile5.y, board.tile[4], NULL, GDBLTFAST_KEYSRC, NULL);
	pBackbuffer->BltFast(board.tile6.x, board.tile6.y, board.tile[5], NULL, GDBLTFAST_KEYSRC, NULL);
	pBackbuffer->BltFast(board.tile7.x, board.tile7.y, board.tile[6], NULL, GDBLTFAST_KEYSRC, NULL);
	pBackbuffer->BltFast(board.tile8.x, board.tile8.y, board.tile[7], NULL, GDBLTFAST_KEYSRC, NULL);
	pBackbuffer->BltFast(board.tile9.x, board.tile9.y, board.tile[8], NULL, GDBLTFAST_KEYSRC, NULL);
    

	if (whoTurn == PLAYERO && onGoing(board))
	{
		compTurn();
	}


	//check board
	for (int i = 0; i < 9; i++)
	{
		if (board.tileStat[i] == XTILE)
		{
			pBackbuffer->BltFast(board.tileRect[i].left, board.tileRect[i].top, playerx.tokImage, NULL, GDBLTFAST_KEYSRC, NULL);
		}
		else 
			if (board.tileStat[i] == OTILE)
			{
				pBackbuffer->BltFast(board.tileRect[i].left, board.tileRect[i].top, playero.tokImage, NULL, GDBLTFAST_KEYSRC, NULL);
				
			}
	}
	
	if (whoTurn == PLAYERX)
	{
		pBackbuffer->BltFast(10,280,XTurn,NULL,GDBLTFAST_KEYSRC,NULL);
	}
	else 
		if (whoTurn == PLAYERO)
		{
			pBackbuffer->BltFast(10,280,OTurn,NULL,GDBLTFAST_KEYSRC,NULL);
		}



	if (isWon(board,PLAYERX))
	{
		pBackbuffer->BltFast(0,0,WonX,NULL,NULL,NULL);
		
	}
	else
		if(isWon(board,PLAYERO))
		{
			pBackbuffer->BltFast(0,0,WonO,NULL,NULL,NULL);
		}
		else
			if (!onGoing(board))
			{
				TCHAR str[10];
				_stprintf(str, TEXT("DRAW"));
				pBackbuffer->DrawText(10,250,str,m_pDisplay->GetSystemFontBorder(), 0, NULL,0,NULL);
			}
	return S_OK;
};

HRESULT CMyApplication::KeyDown(DWORD dwKey, GDKEYLIST& keylist)
{
    // Exit main loop on any key press
    Shutdown();
    return S_OK;
};

HRESULT CMyApplication::StylusDown(POINT p)
{
	for (int i = 0; i < 9; i++)
	{
		if (::PtInRect(&board.tileRect[i], p))
		{
			if (board.tileStat[i] == NONE && whoTurn == PLAYERX && onGoing(board))
			{	
				board.tileStat[i] = XTILE;
				whoTurn = PLAYERO;
			}
			
		}
	}
	return GD_OK;
}

void CMyApplication::compTurn()
{
	board.tileStat[bestMove()] = PLAYERO;
	whoTurn = PLAYERX;
}

int CMyApplication::bestMove()
{
	for (int a = 0; a < 9; a++)
	{
		Board tmpBrd = board;

		if (tmpBrd.tileStat[a] == NONE)
		{
			tmpBrd.tileStat[a] = PLAYERO;
			
			if (isWon(tmpBrd,PLAYERO) && board.tileStat[a] == NONE)
			{
				return a;
			}

			tmpBrd.tileStat[a] = PLAYERX;

			if (isWon(tmpBrd,PLAYERX) && board.tileStat[a] == NONE)
			{
				return a;
			}
		}
				
	}

	for (int i = 0; i < 9; i++)
	{
		if (board.tileStat[compMoves[i]] == NONE)
		{
			return compMoves[i];
		}
	}
	return 0; //i just put it here so that there will be no warning...hehehe....
}


bool CMyApplication::isWon(Board b2,int who)
{
  return  ( (b2.tileStat[0]==who && b2.tileStat[1]==who && b2.tileStat[2]==who) ||
          (b2.tileStat[3]==who && b2.tileStat[4]==who && b2.tileStat[5]==who) ||
          (b2.tileStat[6]==who && b2.tileStat[7]==who && b2.tileStat[8]==who) ||
          (b2.tileStat[0]==who && b2.tileStat[3]==who && b2.tileStat[6]==who) ||
          (b2.tileStat[1]==who && b2.tileStat[4]==who && b2.tileStat[7]==who) ||
          (b2.tileStat[2]==who && b2.tileStat[5]==who && b2.tileStat[8]==who) ||
          (b2.tileStat[0]==who && b2.tileStat[4]==who && b2.tileStat[8]==who) ||
          (b2.tileStat[2]==who && b2.tileStat[4]==who && b2.tileStat[6]==who)  );

};


bool CMyApplication::onGoing(Board b2)
{
	for (int i = 0; i < 9; i++)
	{
		if (b2.tileStat[i] == NONE)
		return true;
	}
	return false;
}
CMyApplication::~CMyApplication() {};


// ----------------------------------------

int APIENTRY WinMain(HINSTANCE hInst, HINSTANCE hPrevInst,
                     LPTSTR pCmdLine, int nCmdShow)
{
    GDAPPCONFIG config;
    ::ZeroMemory(&config, sizeof(GDAPPCONFIG));

    config.hInstance       = hInst;
    config.pAppTitle       = TEXT("TIC - TAC - TOE");
    config.dwMaxFPS        = 30;
    config.dwWindowIcon    = IDI_APP;

    // Create the application
    CMyApplication simple(config);

    // Start main loop
    return simple.Run();
}