#ifndef STRICT
#define STRICT

#include "GapiDraw.h"
#include "GapiApplication.h"
#include "board.h"
#include "token.h"


// ----------------------------------------

class CMyApplication : public CGapiApplication
{
protected:
	DWORD whoTurn;
	int compMoves[9];
public:
	CMyApplication(const GDAPPCONFIG& config);
	virtual HRESULT InitInstance();
	virtual HRESULT ExitInstance();
	virtual HRESULT CreateSysMemSurfaces(CGapiDisplay* pDisplay, HINSTANCE hInstance);
	virtual HRESULT CreateVidMemSurfaces(CGapiDisplay* pDisplay, HINSTANCE hInstance);
	virtual HRESULT ProcessNextFrame(CGapiSurface* pBackbuffer, DWORD dwFlags);
    virtual HRESULT KeyDown(DWORD dwKey, GDKEYLIST& keylist);
	virtual HRESULT StylusDown(POINT p);
	virtual int bestMove();
	virtual bool isWon(Board,int);
	virtual void compTurn();
    virtual ~CMyApplication();
	virtual bool onGoing(Board);
	
	//background
	CGapiSurface *m_backGround;

	//playerx / playero won image
	CGapiSurface *WonX;
	CGapiSurface *WonO;

	//playerx / playero turn image
	CGapiSurface *XTurn;
	CGapiSurface *OTurn;

	//playerx
	Token playerx;

	//player o
	Token playero;

	//board
	Board board;

	
};



#endif
